	.MODEL	TINY
	.CODE

	JMP	INSTALL

OrgInt10v 	dw	2 dup (?)	; ਣ  INT 10
VideoMode       db	0		; ⠭ ०
TextMode	db	0		; 䫠: 0 - ᪨, 1 - ⥪
s3D4		dw	3D4h		;   ॣ஢ 

;---------------------------------------  祭 ॣ 3C2 ---
; videomode	0     1     2     3     4     5     6     7     8     9
; videomode	A     B     C     D     E     F     10    11    12    13
r_3C2	db	0E3h, 0E3h, 0E7h, 0E7h, 0E3h, 0E3h, 0E7h, 0E6h, 0,    0
	db	0,    0,    0,    0E3h, 0E7h, 0E7h, 0E7h, 0E7h, 0E7h, 0E7h

;------------------------------------------  3D4/3D5 (3B4/3B5) ---
Mode_00:
Mode_01:
	db	0, 84
	db	3, 97h
	db	4, 58
	db	5, 20h
	db	0ffh
	dw	offset Kadr_200

Mode_02:
Mode_03:
Mode_07:
	db	0, 6Ch
	db	1, 4Fh
	db	2, 50h
	db	3, 8Fh
	db	4, 91
	db	5, 88h
	db	0FFh
	dw	offset Kadr_200

Mode_04:
Mode_05:
	db	0, 96
	db	1, 39
	db	3, 83h
	db	4, 62
	db	5, 90h
	db	9, 41h
	db	0FFh
	dw	offset Kadr_200

Mode_06:
	db	0, 6ch
	db	1, 4fh
	db	2, 50h
	db	3, 8Fh
	db	4, 5Ah
	db	5, 88h
	db	9, 41h
	db	0FFh
	dw	offset Kadr_200

Mode_0D:
	db	0, 96
	db	1, 39
	db	3, 83h
	db	4, 62
	db	5, 90h
	db	9, 40h
	db	0FFh
	dw	offset Kadr_200

Mode_0F:
Mode_10:
	db	0, 6ch
	db	1, 4fh
	db	2, 50h
	db	3, 8Fh
	db	4, 5Ah
	db	5, 88h
	db	9, 40h
	db	13h, 80
	db	0FFh
	dw	offset Kadr_174

Mode_11:
Mode_12:
	db	0, 6ch
	db	1, 4fh
	db	2, 50h
	db	3, 8Fh
	db	4, 5Ah
	db	5, 88h
	db	9, 40h
	db	13h, 80
	db	0FFh
	dw	offset Kadr_240

Mode_Z:

Mode_0E:
Mode_13:
	db	0, 6ch
	db	1, 4fh
	db	2, 50h
	db	3, 8Fh
	db	4, 5Ah
	db	5, 88h
	db	9, 40h
	db	0FFh
	dw	offset Kadr_200


Kadr_200:				;   200 ப
	db	6, 38h
	db	12h, 199
	db	15h, 203
	db	16h, 53
	db	10h, 250
	db	7, 1
	db	0FFh
	
kadr_240:
	db	06h, 38h
	db	12h, 239
	db	15h, 244
	db	16h, 52
	db	10h, 15
	db	07h, 05h
	db	09h, 40h
	db	0FFh

kadr_290:
	db	06h, 38h
	db	12h, 34
	db	15h, 40
	db	16h, 52
	db	10h, 38
	db	07h, 0Fh
	db	09h, 40h
	db	0Ch, 09h
	db	0Dh, 60h
	db	0FFh
	
kadr_174:
	db	06h, 38h
	db	12h, 174
	db	15h, 190
	db	16h, 42
	db	10h, 238
	db	07h, 01h
	db	09h, 40h
	db	0FFh

;Mode_Z:
	db	0FFh

ModeTable	LABEL	WORD
	dw	offset Mode_00		; 00
	dw	offset Mode_01		; 01
	dw	offset Mode_02		; 02
	dw	offset Mode_03		; 03
	dw	offset Mode_04		; 04
	dw	offset Mode_05		; 05
	dw	offset Mode_06		; 06
	dw	offset Mode_07		; 07+
	dw	offset Mode_Z		; 08
	dw	offset Mode_Z		; 09
	dw	offset Mode_Z		; 0A
	dw	offset Mode_Z		; 0B
	dw	offset Mode_Z		; 0C
	dw	offset Mode_0D		; 0D
	dw	offset Mode_0E		; 0E
	dw	offset Mode_0F		; 0F
	dw	offset Mode_10		; 10
	dw	offset Mode_11		; 11
	dw	offset Mode_12		; 12
	dw	offset Mode_13		; 13

;--------------------------------------------------------------------------

OrgInt10:
	pushf
	call	dword ptr cs:OrgInt10v
	ret

SwitchMode:
	mov	al, [bx]
	inc	bx
	cmp	al, 0FFh
	je      swm1
	out	dx, al
	inc	dx
	mov	al, [bx]
	inc	bx
	out	dx, al
	dec	dx
	jmp	SwitchMode
swm1:
	ret

;------------------------------------------------------ INT 10 handler ----
HANDLER_INT_10:
	cmp	ah, 0
	je	ChangeMode
	cmp	ah, 11h
	je	SetFont
	cmp	ax, 0ABCDh
	je	My_Functions

	call	OrgInt10
	IRET

My_Functions:
	mov	ax, 0ACDCh		;  ⢨
	mov	bx, cs
	IRET

SetFont:
	mov	cs:TextMode, al
	and	cs:TextMode, 0EFh
	cmp	cs:TextMode, 1		; set font 8x14 ?
	je	@sf_8x8
	cmp	cs:TextMode, 2		; set font 8x8 ?
	je	@sf_8x8
	cmp	cs:TextMode, 4		; set font 8x16 ?
	jne	@sf_GO

@sf_8x8:
	mov	ax, 3			; !!!  ,         !!!
	jmp	ChangeMode		; !!!      譮 !!!

@sf_GO:
	call	OrgInt10
	push	ax es
	xor	ax, ax
	mov	es, ax
	mov	byte ptr es:[484h], 24	; 25 ⥪⮢ ப  ࠭
	pop	es ax
	IRET

ChangeMode:
	push	ax bx cx dx ds es
	xor	bx, bx
	mov	es, bx
	push	cs
	pop	ds
	mov	VideoMode, al
	and	VideoMode, 7Fh
	mov	TextMode,  0
	mov	s3D4, 3D4h		;   ॣ஢ 

	cmp	VideoMode, 13h		; ० ন ?
	jbe	cm0
	jmp	EXIT			;  - 室
cm0:	xor	bx, bx
	mov	bl, VideoMode
	cmp	r_3c2[bx], 0		; ० ন ?
	jne	cm1
	jmp	EXIT			;  - 室
cm1:

	call	OrgInt10		; ⠭  ०
	cmp	VideoMode, 3		;  ⥪⮢ ?
	jbe	Switch_8x8
	cmp	VideoMode, 7            ;  TTL mono text ?
	jne	GlobalMode		;  ⥪⮢ -> 騥 ன
	mov	s3D4, 3B4h		; TTL mono -  १ 3B4/3B5

Switch_8x8:
	mov	TextMode, 1		; ⮢ - ⠭ 䫠
	mov	ax, 1112h		; ⠭ 䮭 8x8
	xor	bl, bl
	call	OrgInt10
	mov	byte ptr es:[484h], 24	; 25 ⥪⮢ ப  ࠭

GlobalMode:

;------------------------------ ன 騥   ० ----

;	        *** ᬥ ୮ ஢  筮  ⥫
;		*** 롮 ⠪⮢ 

	mov	dx, 3c2h
	xor	bx, bx
	mov	bl, VideoMode
	mov	al, r_3c2[bx]
	out	dx, al			;  - ணࠬ㥬

;--------------------------------  ⥫ ᫥⥫쭮 ---

	mov	dx, 3c4h		; 롮:
	xor	al, al
	out	dx, al			;         ॣ 
	inc	dx
	in	al, dx
	and	al, 0fdh		; ᨭ஭ 
	out	dx, al

	mov	dx, 3c4h               	; 롮:
	mov	ax, 1			;	  ॣ ᨭ஭樨
	out	dx, al
	inc	dx
	in	al, dx
	or	al, 8			;  ⠪ 窨  2
	cmp	TextMode, 1		; ० ⥪⮢ ?
	jne	@@1
	cmp	VideoMode, 2		; ० ⥪ 80x25 ?
	jb	@@1
	or	al, 1			;  - 8 ⠪⮢  ᨬ
@@1:	out	dx, al

	mov	dx, 3c4h		; 롮:
	xor	al, al
	out	dx, al			;         ॣ 
	inc	dx
	in	al, dx
	or	al, 3			;  
	out	dx, al

;---------------------------------------   3d4/3d5 (3b4/3b5)---
;-- 襭 ணࠬ஢ ॣ஢ 0-7,롮 5 横 ⠭

	mov	dx, s3d4		; 롮:
	mov	al, 11h                 ;   " ⭮ 室
	out	dx, al			;    "
	inc	dx
	in	al, dx
	and	al, 7Fh			;   
	or	al, 40h			; 5 横 ⠭
	out	dx, al			; 堫 !

;--------------------------------------------------------------------------

	xor	bx, bx
	mov	bl, VideoMode
	shl	bx, 1
	mov	bx, ModeTable[bx]
	mov	dx, s3D4
	call	SwitchMode		; BX 㪠뢠  ன ஢

	mov	bx, [bx]		;  ⠡ ஢  BX
	call	SwitchMode		; ࠨ 

Exit:
;----------------------------------------   -3d4h -3d5h ---
;                             - 饭 ணࠬ஢ ॣ஢ 0-7 -
	mov	dx, s3d4
	mov	al, 11h
	out	dx, al
	inc	dx
	in	al, dx
	or	al, 80h
	out	dx, al
;--------------------------------------------------------------------------
	pop	es ds dx cx bx ax
	IRET


;******************************************************** INSTALL Part ***
INSTALL:
	push	cs
	pop	ds

	mov	ax, 0ABCDh
	int	10h
	cmp	ax, 0ACDCh
	je	Already

	mov	ax, 3510h
	int	21h
	mov	OrgInt10v+2, es
	mov	OrgInt10v,   bx

	mov	ax, 2510h
	lea	dx, HANDLER_INT_10
	int	21h

	call	TITUL

	lea	dx, INSTALL
	mov	cl, 4
	shr	dx, cl
	add	dx, 11h

	MOV	AX, 3100h
	INT	21h

Already:
	call	TITUL
	mov	ax, 4c01h
	int	21h

;---------------------------------------------------- TITUL ---------
TITUL:
	mov	ax, 3
	int	10h
	lea	bx, @Titul
	call	WriteStr
	call	ColorShift
	RET

WriteStr:
	mov	ah, 0eh
	mov	al, [bx]
	cmp	al, 0
	je	@wrs_exit
	int	10h
	inc	bx
	jmp	WriteStr
@wrs_exit:
	ret

PushColor:
	push	ax
	mov	ax, 0B800h
	mov	es, ax
	mov	bx, 157
@push:	mov	al, es:[bx]
	mov	es:[bx+2], al
	sub	bx, 2
	jnc	@push
	pop	ax
	mov	es:[bx+2], al
	RET

Wait_10ms:
	push	ax
	push	cx
	mov	dx, 378h
	mov	cx, 10000		; Pause 10 msec
@Wait_L1:
	in	al, dx			; Delay 1 micro sec
	loop	@Wait_L1
	pop	cx
	pop	ax
	RET


ColorShift:
	mov	al, 15
	mov	cx, 7
@cc1:	push	cx
	mov	cx, 15
@cc2:	call	PushColor
	call	wait_10ms
	loop	@cc2
	pop	cx
	dec	al
	loop	@cc1
	mov	cx, 80
	mov	al, 11
@cc3:	call	PushColor
	call	wait_10ms
	loop	@cc3
	RET

;------------------------------------------------- MESSAGES -----------------
@Titul:
	db	'TV-VGA BIOS Extender. Copyright (c) 1993 Dmitry Skornyakov, FREEWARE',13,10
	db	13,10
	db	'Russia, Izhevsk phones: (3412) 785735, 229335',13,10
	db	'E-mail: dis@lota.udmurtia.su     (work)',13,10
	db	'        dis@dis.lota.udmurtia.su (home)',13,10
	db	0

COPYRIGHT:
 db 13,10,13,10
 db '͸',13,10
 db '       ணࠬ - ࠩ  VGA  祭         ',13,10
 db '       ⮬ ᮢ ⥫ ᯮ  RGB + Sincro       ',13,10
 db 'Ĵ',13,10
 db '    ᪨ ࠢ ਭ 类  ᫠   ',13,10
 db '      Copyright (C) August 1993, Dmitry Skornyakov, FREEWARE          ',13,10
 db '          Post:       Russia, Izhevsk, 426069 / 750                 ',13,10
 db '          Phone:      (3412) 785735, 785709    (work)                 ',13,10
 db '                      229335                   (home)                 ',13,10
 db '          E-mail:     dis@lota.udmurtia.su     (work)                 ',13,10
 db '                      dis@dis.lota.udmurtia.su (home)                 ',13,10
 db 'Ĵ',13,10
 db '    ࠧ蠥 ᯮ짮  ࠭  ணࠬ   ',13,10
 db '    祭 ᪮ 룮,  ⠪-  䨪     ',13,10
 db '     ࠭  ᢥ     ணࠬ.       ',13,10
 db '    ⢥⢥      , ணࠬ    ',13,10
 db '     ।,  ந襤    १  ᯮ짮   ',13,10
 db '   ⮩ ணࠬ.                                                    ',13,10
 db ';',13,10
 db 13,10
	END	INSTALL
